void
mul_mat ( const unsigned n, const unsigned m, const unsigned k,
          const double alpha, const double * A, const double * B,
          double * C )
{
    for ( unsigned i = 0; i < n; i++ )
        for ( unsigned j = 0; j < m; j++ )
        {
            double  f = 0.0;
            
            for ( unsigned l = 0; l < k; l++ )
                f += get_entry( n, k, i, l, A ) *
                     get_entry( k, m, l, j, B );

            add_entry( n, m, i, j, f, M );
        }
}
