// vector functions
void fill  ( const double f, vector_t & x );
void scale ( const double f, vector_t & x );

void add   ( const double f, const vector_t & x, vector_t & y )
{
    for ( unsigned i = 0; i < n; i++ )
        y.coeffs[i] += f * x.coeffs[i];
}

double        dot   ( const vector_t & x, const vector_t & y );
inline double norm2 ( const vector_t & x )
{ return sqrt( dot( x, x ) ); }

// matrix functions
void fill  ( const double f, matrix_t & M );
void scale ( const double f, matrix_t & M );
void add   ( const double f, const matrix_t & A, matrix_t & M );

inline double
normF ( double & M )
{ ... }  // can not use vector based norm2!
