struct vector_t {
private:               // all following variables and functions 
    size_t    size;    // are private
    real_t *  coeffs;

public:                // all following variables and functions 
                       // are public
    vector_t ( const size_t  n );
...
    size_t  get_size () const { return size; }
};

...

{
    vector_t  x( 10 );

    cout << x.size << endl;        // ERROR: <size> is private
    cout << x.get_size() << endl;  // Ok: <get_size> is public
}
