struct vector_t {
    ...
    // provide index operator for vectors
    real_t  operator [] ( const size_t i ) { return coeffs[i]; }

    // arithmetics
    vector_t &  operator += ( const vector_t & v )
    {
        for ( size_t i = 0; i < size; i++ ) coeffs[i] += v.coeffs[i];
        return *this;
    }
    vector_t &  operator -= ( const vector_t & v ) { ... }
    vector_t &  operator *= ( const real_t  f )
    {
        for ( size_t i = 0; i < size; i++ ) coeffs[i] *= f;
        return *this;
    }
    ...
};

{ ...
    x += y;
    y *= 2.0;
}
