class matrix_t {
private:
    size_t  nrows, ncolumns;
public:
    matrix_t  ( const size_t  n, const size_t  m );
    matrix_t  ( const matrix_t &  M );

    size_t  get_nrows    () const { return nrows };
    size_t  get_ncolumns () const { return ncolumns };

    void   fill    ( const real_t  f );
    void   scale   ( const real_t  f );
    void   add     ( const real_t  f, const matrix_t & x );
    void   mul_vec ( const real_t  alpha, const vector_t & x,
                     vector_t &    y ) const;
    real_t normF   () const;
};
