struct vector_t {
    size_t    size;
    real_t *  coeffs;
};

struct matrix_t {
    size_t    nrows, ncolumns;
    real_t *  coeffs;
};

void
mul_vec ( const real_t      alpha,
          const matrix_t &  A,
          const vector_t &  x,
          vector_t &        y );

struct triangle_t {
    int     vtx_idx[3];  // indices to a vertex array
    real_t  normal[3];
    real_t  area;
};
