void
mul_vec ( const real_t   alpha, const crsmatrix_t & S,
          const vector_t x, vector_t & y )
{
    for ( unsigned row = 0; row < S.nrows; row++ )
    {
        real_t         f  = 0.0;
        const unsigned lb = S.rowptr[ row ];
        const unsigned ub = S.rowptr[ row+1 ];

        for ( unsigned j = lb; j < ub; j++ )
            f += S.coeffs[ j ] * x[ S.colind[ j ] ];

        y[ i ] += alpha * f;
    }
}
