void
mul_vec ( const double      alpha,
          const matrix_t &  M,
          const vector_t &  x,
          vector_t &        y )
{
    for ( unsigned i = 0; i < M.nrows; i++ )
    {
        double  f = 0.0;

        for ( unsigned j = 0; j < M.ncolumns; j++ )
            f += get_entry( M, i, j ) * x.coeffs[j];

        y.coeffs[i] += alpha * f;
    }
}

void
mul_mat ( const double      alpha,
          const matrix_t &  A,
          const matrix_t &  B,
          matrix_t &        C );
