class matrix_t {
private:
    size_t    nrows, ncolumns;
    real_t *  coeffs;

public:
    matrix_t  ( const size_t  n, const size_t  m );
    matrix_t  ( const matrix_t &  M );
    ~matrix_t ();

    size_t  get_nrows    () const;
    size_t  get_ncolumns () const;

    real_t   operator [] ( const size_t i, const size_t j ) const;
    real_t & operator [] ( const size_t i, const size_t j );

    void fill  ( const real_t  f );
    void scale ( const real_t  f );
    void add   ( const real_t  f, const matrix_t & M );
