void cg ( const matrix_t &  A, vector_t & x, const vector_t & b )
{
    vector_t  r( b ), p, a( x.get_size() );

    A.mul_vec( -1.0, x, r );   p = r;

    for ( size_t it = 0; it < 1000; it++ ) {
        real_t  lambda;

        a.fill( 0.0 );
        A.mul_vec( 1.0, p, a );
        lambda = dot( r, p ) / dot( a, p );
        x.add(  lambda, p );
        r.add( -lambda, a );
        p.scale( - dot( r, a ) / dot( a, p ) );
        p.add( 1.0, r ); 
        
        if ( r.norm2() < 1e-10 )
            break;
}   }
