#include <valarray>

class vector_t
{
private:
    std::valarray< real_t >  coeffs;

public:
    vector_t ( const size_t      n ) { coeffs.resize( n ); }
    vector_t ( const vector_t &  v );

    real_t operator [] ( const size_t i ) const
    { return coeffs[i]; }

    vector_t & operator = ( const vector_t &  v )
    {
        coeffs = v.coeffs;
        return *this;
    }
};
